import processing.core.*;
import processing.video.*;

class FlickrUploader {
  String APIKEY = "db5d5845a512ffa2bd8bea2007f99f0c";
  String APISECRET = "4462e701e7496444";
  String APPNAME = "neon_play";
  
  void upload(String filename) {
  
  }
    
}


class Graffiti {
  PApplet main;
  PImage buffer;
  PImage[] brushes;
  PImage brush;
  int previousX, previousY;
  int dotX, dotY;
  boolean drawing;
  int pTopLeftX, pTopLeftY, pTopRightX, pTopRightY, pBottomLeftX, pBottomLeftY, pBottomRightX, pBottomRightY; 
  float pWidth, pMaxHeight, pMinHeight;
  float pHeightAspect;
  int previousMillis = 0;
  int curBrushIndex = 0;
  boolean isEmpty = true;
  
  public Graffiti(PApplet main) {
   this.main = main;
   buffer = createImage(main.width, main.height, ARGB);
   
   brushes = new PImage[5];
   brushes[0] = loadImage("brush-round.png");
   brushes[1] = loadImage("brush-round-magenta.png");
   brushes[2] = loadImage("brush-round-navy.png");
   brushes[3] = loadImage("brush-round-green.png");
   brushes[4] = loadImage("brush-round-yellow.png");
   brush = brushes[0];

   pTopLeftX     = 241;   pTopLeftY     = 9;
   pTopRightX    = 643;  pTopRightY    = 9;
   pBottomLeftX  = 241;   pBottomLeftY  = 417;
   pBottomRightX = 643;  pBottomRightY = 417;
   
   pWidth = pTopRightX - pTopLeftX;
   pMaxHeight = max( (pBottomLeftY - pTopLeftY), (pBottomRightY - pTopRightY) );
   pMinHeight = min( (pBottomLeftY - pTopLeftY), (pBottomRightY - pTopRightY) );
   pHeightAspect = pMinHeight / pMaxHeight;
  }
  
  public void draw(int x, int y) {
    
    isEmpty = false;
    
    // see if we need to draw a line between dots
    int deltaX = x - previousX;
    int deltaY = y - previousY;
    float cx = previousX, cy = previousY;
    float distance = sqrt( pow(deltaX, 2) + pow(deltaY, 2) );
    
    int index = (int)random(0,4);
    
    if(distance < 50 && distance > 1 && (millis() - previousMillis) < 500) {
      for(int i = 0; i < distance; i++) {
        cx += (deltaX / distance);
        cy += (deltaY / distance);
        buffer.blend(brushes[curBrushIndex], 0, 0, 15, 15, (int)cx - 7, (int)cy - 7, 15, 15, BLEND);
      }
    } else {
      buffer.blend(brushes[curBrushIndex], 0, 0, 15, 15, x - 7, y - 7, 15, 15, BLEND);
    }
    previousX = x;
    previousY = y;
    previousMillis = millis();
  }
  
  public void findDot(int[] pixelArray) {
    drawing = false;
    int spot = 0;
    int bestResult = 0;
    int bB = 0, bG = 0;
    for(int i = 0; i < pixelArray.length; i++) {
      color c = pixelArray[i];
      
      int r = (c >> 16) & 0xFF;
      int g = (c >> 8) & 0xFF;
      int b = c & 0xFF;
        
      if(r > 225 && b < 100 && g < 100) { // a basic treshold
        int result = constrain(r * 2 - b - g, 0, 1000);
        // setMsg("got result: "+result);
        if(result > bestResult && result > 300) {
          // setMsg("got result: "+result+" is good!");
          bestResult = result;
          spot = i;
          bG = g; bB = b;
        } 
      }
    }
    
    if(bestResult > 0) {
      dotY = spot / buffer.width;
      dotX = spot % buffer.width;
      drawing = true;
      // setMsg("found dot at "+dotX+","+dotY+" with: "+bestResult+","+bG+","+bB);
    }
        
  }
  
  public void show() {
    main.image(buffer, 0, 0);
  }
  public void clear() {
    buffer = createImage(main.width, main.height, ARGB);
    isEmpty = true;
  }
}

class ImageSnapper {
 
  Capture video;
  PApplet main;
  PImage dblBuffer;
  PImage[] rememberedFrames;
  int rememberedFramesAmount = 5;
  int curFrameIndex;
  int[] alphaMask;
  boolean isEmpty = true;
  
  public ImageSnapper(PApplet mainProcessingThread) {
    main = mainProcessingThread;
    main.loadPixels();
    println(Capture.list());
    dblBuffer = createImage(main.width, main.height, ARGB);
    video = new Capture(main, main.width, main.height); //, "IIDC FireWire Video", 16);
    alphaMask = new int[video.height * video.width];
    rememberedFrames = new PImage[ rememberedFramesAmount ];
    for(int i = 0; i < rememberedFramesAmount; i++) {
      rememberedFrames[i] = createImage(video.width, video.height, ARGB);
    }
    curFrameIndex = 0;
  }
  
  public ImageSnapper shoot() {
    if(video.available()) {
      video.read();
      video.loadPixels();
    } 
    return this;
  }
  
  public ImageSnapper reduceColors(int factor) {

    for(int i = 0; i < video.width * video.height; i++) {
      color c = video.pixels[i];
      int r = (c >> 16) & 0xFF;
      int g = (c >> 8) & 0xFF;
      int b = c & 0xFF;
      
      r = (int)( r / factor * factor );
      g = (int)( g / factor * factor );
      b = (int)( b / factor * factor );
    
      if((r + g + b) > 20) {
        video.pixels[i] = color(r, g, b, 255);
        alphaMask[i] = constrain(r * 3, 0, 255);
      } else { 
        video.pixels[i] = 0xFF000000; // make it transparent
        alphaMask[i] = 0;
      }
     }
    
    video.updatePixels();
    
    return this;
  }
  
  public ImageSnapper show() {
    dblBuffer.loadPixels();
    video.loadPixels();
    arraycopy(video.pixels, dblBuffer.pixels);
    dblBuffer.updatePixels();
    dblBuffer.mask(alphaMask);
    main.image(dblBuffer, 0, 0);

    return this;
  }
  
  public PImage rememberImage() {
    PImage curFrame = rememberedFrames[curFrameIndex];
    curFrame.loadPixels();
    dblBuffer.loadPixels();
    
    arraycopy(dblBuffer.pixels, curFrame.pixels);
    curFrame.updatePixels();
    isEmpty = false;
    return curFrame;
  }
  
  public void clear() {
    println("clearing captures..");
    for(int i = 0; i < rememberedFramesAmount; i++) {
      rememberedFrames[i].loadPixels();;
    }  
    for(int c = 0; c < dblBuffer.width * dblBuffer.height; c++)
      for(int i = 0; i < rememberedFramesAmount; i++) {
        rememberedFrames[i].pixels[c] =  0x00000000;;
      }
    for(int i = 0; i < rememberedFramesAmount; i++) {
      rememberedFrames[i].updatePixels();;
    }
    isEmpty = true; 
  }
  
}



ImageSnapper snap;
Graffiti graf;
StringBuffer msg = new StringBuffer("mlab rulz");
boolean photoTaken = false;
boolean saveScreen = false;
boolean saved = false;

void setup() {
  size(640, 480);
  snap = new ImageSnapper(this);
  graf = new Graffiti(this);
  background(0);
  PFont font = loadFont("Arcade-48.vlw");
  textFont(font, 32);
}

void draw() {
  
  // empty the screen with a black background
  fill(0);
  rect(0, 0, width, height);
  
  // show a message
  fill(230);
  text(msg.toString(), 15, 30);

  // record what we see
  snap.shoot();
  
  if(photoTaken && !saveScreen) {
    graf.findDot(snap.video.pixels);
    if(graf.drawing) {
      graf.draw(graf.dotX, graf.dotY);
    }
    tint(color(255, 255, 255), 90);
    image(snap.rememberedFrames[0], 0, 0);
    noTint();
    
    graf.show();
    image(graf.brushes[graf.curBrushIndex], width - 30, 0, 30, 30);
  } 
  
  else if(saveScreen) {
    noTint();
    image(snap.rememberedFrames[0], 0, 0);    
    graf.show();
    
    save("images/mlab-08-art-"+hour()+":"+minute()+":"+second()+".jpg");  
    saveScreen = false;
    setMsg("saved image. hit a key to go again");
    saved = true;
  } 
  
  else {
    snap.reduceColors(80);
    snap.show();
  }
}


void keyPressed() {
  if(saved) {
    graf.clear();
    snap.clear();
    setMsg("mlab rulz");
    saved = false;
    photoTaken = false;
  } else if(keyCode == ENTER && !photoTaken) {
    println("( * ) taking snapsnot");
    snap.rememberImage();
    photoTaken = true;
  } else if(keyCode == ENTER) {
    println("( * ) saving screen");
    saveScreen = true;
  } else if(keyCode == BACKSPACE) {
    if(!graf.isEmpty)
      graf.clear();
    else if(!snap.isEmpty) {
      snap.clear();
      photoTaken = false;
    } else
      msg.deleteCharAt(msg.length() - 1); 
  } else if(keyCode == RIGHT) {
    graf.curBrushIndex++;
    if(graf.curBrushIndex > 4)
      graf.curBrushIndex = 0;
  } else if(keyCode == LEFT) {
    graf.curBrushIndex--;
    if(graf.curBrushIndex < 0)
      graf.curBrushIndex = 4;
  } else if(!photoTaken) {
    print("wtf? : "+key);
    msg.append(key);
  }
  
  redraw();
  
}

void mousePressed() {
  println("mouse pressed at "+mouseX+","+mouseY);
  graf.draw(mouseX, mouseY); 
}

void mouseDragged() {
  graf.draw(mouseX, mouseY);  
}

public void setMsg(String msg) {
  this.msg.replace(0, this.msg.length(), msg);
}
